<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] ?: array()) + array("_27de5a45db71bf24058769" . "b61b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVja" . "WZpZWQ="), "_a8b22fedb27a11e07f5bb9a7c73608" . "ea" => base64_decode("c3RyKDEwMCk6b" . "2JqZWN0X2NvZG" . "U="), "_0877a0b48cf424a0de57" . "a453ce95e30c" => base64_decode("aW50OnVzZ" . "XJfaWQ="), "_c95cbc316178c97697a403f4d" . "9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6" . "c3RyOmNvZGU="), "_a7ed4d7408bb99b87a" . "09d89d4212d5de" => base64_decode("c2ltcGxl" . "X2FjbA=="), "_80fc2a45acd0150df87d1" . "fb728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ" . "9aW50OnVpZA=="), "_ef2948c87ef38aab9226e41189b2" . "9ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y2" . "9kZQ=="), "_938704c4c0169c3804d4bd6aa9" . "941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vd" . "CBzcGVjaWZpZWQ="), "_b06968b9268deaf" . "3b380bd0fe922b45" . "3" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9" . "pZD1pbnQ6dWlk"), "_84718d828d2acc3c366f96b07e8" . "41f6a" => base64_decode("YWNsLnNpbX" . "BsZQ=="), "_3cda3f34ada" . "928e4aa39d46" . "29c5504aa" => base64_decode("aW50OnJpZ2h0cw=" . "="), "_dbbe14f567693a631f8a43b65af9" . "17ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tI" . "GRhdGFiYXNlOiBvYmplY3QgY29kZS" . "Bub3Qgc3BlY2lmaWVk"));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_84718d828d2acc3c366f96b07e841f" . "6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_80fc2a4" . "5acd0150" . "df87d1fb" . "728940a6" . "0"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_a7ed4d7408" . "bb99b87a09d" . "89d4212d5de"], [$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_a8b22fedb27a11e" . "07f5bb9a7c73608e" . "a"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_0877a0b48cf424a0de5" . "7a453ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_3cda3f34ada928e4aa39d46" . "29c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_b06968b9268deaf3b380bd0" . "fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_938704c4c0169c3804d4bd6aa9" . "941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_c95cbc316178c97697a403f4" . "d9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_27de5a45db71bf24058" . "769b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_dbbe14f567693a631f8a43b65af9" . "17ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_ef2948c87ef38aab9226e" . "41189b29ca7"], $acl->GetObjectCode());
    }
}